#include <bits/stdc++.h>

using namespace std;
#define ld long double
#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()
//#define int long long
vector<vector<int>> g;
vector<vector<int>> lca;
vector<int> h, par, dist1;
set<pair<int, int>> dist;
int n, k, t;
const int f = 20;

void dfs(int v, int p) {
    dist1[v] = dist1[p] + 1;
    dist.insert({dist1[v], v});
    par[v] = p;
    h[v] = h[p] + 1;
    lca[0][v] = p;
    for (int i = 1; i < f; ++i) {
        lca[i][v] = lca[i - 1][lca[i - 1][v]];
    }
    for (int i: g[v]) {
        if (i == p) {
            continue;
        }
        dfs(i, v);
    }
}

int binup(int v, int r) {
    for (int i = f - 1; i >= 0; i--) {
        if ((1 << i) <= r) {
            r -= (1 << i);
            v = lca[i][v];
        }
    }
    return v;
}

int solve(int v) {
    dist1[v] = -1;
    dfs(v, v);
    int l = 0;
    int r = n + 1;
    vector<int> dist2 = dist1;
    set<pair<int, int>> d2 = dist;
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        vector<pair<int, int>> was;
        for (int i = 0; i < k; ++i) {
            if (dist.empty()) {
                break;
            }
            while (!dist.empty()) {
                auto it = dist.end();
                it--;
                bool was1 = false;
                for (auto j: was) {
                    if (j.second - it->first <= mid - 1 && binup(j.first, j.second - it->first) == it->second) {
                        was1 = true;
                        break;
                    }
                }
                if (was1) {
                    dist.erase(it);
                } else {
                    break;
                }
            }
            auto it = dist.end();
            it--;
            if (it->first <= mid) {
                break;
            } else {
                int f = binup(it->second, mid - 1);
                was.pb({it->second, it->first});
                dist.erase({dist1[f], f});
            }
        }
        while (!dist.empty()) {
            auto it = dist.end();
            it--;
            bool was1 = false;
            for (auto j: was) {
                if (j.second - it->first <= mid - 1 && binup(j.first, j.second - it->first) == it->second) {
                    was1 = true;
                    break;
                }
            }
            if (was1) {
                dist.erase(it);
            } else {
                break;
            }
        }
        if (dist.empty()) {
            r = mid;
        } else {
            auto it = dist.end();
            it--;
            if (it->first > mid) {
                l = mid;
            } else {
                r = mid;
            }
        }
        dist = d2;
        dist1 = dist2;
    }
    dist.clear();
    return r;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//#endif
    cin >> n >> k >> t;
    g.resize(n + 1);
    lca.resize(f, vector<int>(n + 1));
    h.resize(n + 1);
    par.resize(n + 1);
    dist1.resize(n + 1);
    bool was = false;
    for (int i = 0; i < n - 1; ++i) {
        int l, r;
        cin >> l >> r;
        if (r != l + 1) {
            was = true;
        }
        g[l].pb(r);
        g[r].pb(l);
    }
    if (was) {
        if (t == 0) {
            cout << solve(1);
        } else {
            for (int i = 1; i <= n; ++i) {
                cout << solve(i) << " ";
            }
        }
    } else {
        if (t == 0) {
            int l = 0;
            int r = n + 1;
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                int kol = max(0, (n - 1 + mid - 1) / mid - 1);
                if (kol <= k) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            cout << r;
        } else {
            for (int i = 1; i <= n; ++i) {
                int l = 0;
                int r = n + 1;
                while (l + 1 < r) {
                    int mid = (l + r) / 2;
                    int kol = max(0, (n - i + mid - 1) / mid - 1) + max(0, (i - 1 + mid - 1) / mid - 1);
                    if (kol <= k) {
                        r = mid;
                    } else {
                        l = mid;
                    }
                }
                cout << r << " ";
            }
        }
    }
    return 0;
}