#include <bits/stdc++.h>

using namespace std;
#define ld long double
#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()
//#define int long long
vector<vector<int>> g;
vector<int> h, par, dist1;
set<pair<int, int>> dist;
vector<vector<int>> d;
int n, k, t;
const int f = 20;

void dfs(int v, int p) {
    dist1[v] = dist1[p] + 1;
    dist.insert({dist1[v], v});
    par[v] = p;
    h[v] = h[p] + 1;
    int now = v;
    for (int i = 0; i < n; ++i) {
        d[v][i] = now;
        now = par[now];
    }
    for (int i: g[v]) {
        if (i == p) {
            continue;
        }
        dfs(i, v);
    }
}

void dfs1(int v) {
    for (int i: g[v]) {
        if (i != par[v] && dist1[i] > dist1[v] + 1) {
            dist.erase({dist1[i], i});
            dist1[i] = dist1[v] + 1;
            dist.insert({dist1[i], i});
            dfs1(i);
        }
    }
}

int solve(int v) {
    dist1[v] = -1;
    dfs(v, v);
    int l = 0;
    int r = n + 1;
    vector<int> dist2 = dist1;
    set<pair<int, int>> d2 = dist;
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        for (int i = 0; i < k; ++i) {
            auto it = dist.end();
            it--;
            if (it->first <= mid) {
                break;
            } else {
                int f = d[it->second][mid - 1];
                dist.erase({dist1[f], f});
                dist1[f] = 1;
                dist.insert({dist1[f], f});
                dfs1(f);
            }
        }
        auto it = dist.end();
        it--;
        if (it->first > mid) {
            l = mid;
        } else {
            r = mid;
        }
        dist = d2;
        dist1 = dist2;
    }
    dist.clear();
    return r;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//#endif
    cin >> n >> k >> t;
    g.resize(n + 1);
    d.resize(n + 1, vector<int>(n));
    h.resize(n + 1);
    par.resize(n + 1);
    dist1.resize(n + 1);
    for (int i = 0; i < n - 1; ++i) {
        int l, r;
        cin >> l >> r;
        g[l].pb(r);
        g[r].pb(l);
    }
    if (t == 0) {
        cout << solve(1);
    } else {
        for (int i = 1; i <= n; ++i) {
            cout << solve(i) << " ";
        }
    }
    return 0;
}