#include <bits/stdc++.h>

using namespace std;
#define pb push_back
#define all(x) x.begin(), x.end()
vector<vector<int>> g;
vector<int> dist1, dist2;
int n, k, t;
const int f = 18;

void dfs(int v, int p) {
    dist1[v] = dist1[p] + 1;
    dist2[dist1[v]]++;
    for (int i: g[v]) {
        if (i == p) {
            continue;
        }
        dfs(i, v);
    }
}

int solve(int v) {
    dist2.assign(n + 1, 0);
    dist1[v] = -1;
    dfs(v, v);
    int l = 0;
    int r = n + 1;
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        int kol = 0;
        int otv = 1e9;
        for (int j = 1; j <= mid + 1; j++) {
            for (int i = j; i <= n; i += mid) {
                kol += dist2[i];
            }
            otv = min(otv, kol);
            kol = 0;
        }
        if (otv <= k) {
            r = mid;
        } else {
            l = mid;
        }
    }
    return r;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//#endif
    cin >> n >> k >> t;
    g.resize(n + 1);
    dist1.resize(n + 1);
    bool was = false;
    for (int i = 0; i < n - 1; ++i) {
        int l, r;
        cin >> l >> r;
        if (r != l + 1) {
            was = true;
        }
        g[l].pb(r);
        g[r].pb(l);
    }
    if (was) {
        if (t == 0) {
            cout << solve(1);
        } else {
            for (int i = 1; i <= n; ++i) {
                cout << solve(i) << " ";
            }
        }
    } else {
        if (t == 0) {
            int l = 0;
            int r = n + 1;
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                int kol = max(0, (n - 1 + mid - 1) / mid - 1);
                if (kol <= k) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            cout << r;
        } else {
            for (int i = 1; i <= n; ++i) {
                int l = 0;
                int r = n + 1;
                while (l + 1 < r) {
                    int mid = (l + r) / 2;
                    int kol = max(0, (n - i + mid - 1) / mid - 1) + max(0, (i - 1 + mid - 1) / mid - 1);
                    if (kol <= k) {
                        r = mid;
                    } else {
                        l = mid;
                    }
                }
                cout << r << " ";
            }
        }
    }
    return 0;
}
