#include <bits/stdc++.h>

using namespace std;
#define pb push_back
#define ll long long
#define all(x) x.begin(), x.end()
const int N = 1e5 + 1;
int L[N], R[N], t[N], otv[N];

int sum = 1;

void dfs(int v) {
    if (v == 0) {
        return;
    }
    if (t[v] == -1) {
        otv[v] = sum;
        sum++;
        dfs(L[v]);
        dfs(R[v]);
    } else if (t[v] == 0) {
        dfs(L[v]);
        otv[v] = sum;
        sum++;
        dfs(R[v]);
    } else {
        dfs(L[v]);
        dfs(R[v]);
        otv[v] = sum;
        sum++;
    }
}

struct triple {
    int l, r, x;
};
int d[N * 4], p[N * 4];

void build3(int v, int l, int r) {
    p[v] = 2;
    if (l == r) {
        d[v] = -1;
        return;
    }
    int m = (l + r) / 2;
    build3(2 * v, l, m);
    build3(2 * v + 1, m + 1, r);
}

void push3(int v) {
    if (p[v] != 2) {
        p[2 * v] = p[v];
        p[2 * v + 1] = p[v];
        d[2 * v] = p[v];
        d[2 * v + 1] = p[v];
        p[v] = 2;
    }
}

void update3(int v, int l, int r, int x, int y, int zn) {
    if (l > y || x > r) {
        return;
    }
    if (l >= x && r <= y) {
        d[v] = zn;
        p[v] = zn;
        return;
    }
    int m = (l + r) / 2;
    push3(v);
    update3(2 * v, l, m, x, y, zn);
    update3(2 * v + 1, m + 1, r, x, y, zn);
}

void find3(int v, int l, int r) {
    if (l == r) {
        t[l] = d[v];
        return;
    }
    int m = (l + r) / 2;
    push3(v);
    find3(2 * v, l, m);
    find3(2 * v + 1, m + 1, r);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, q;
    cin >> n >> q;
    for (int i = 1; i <= n; ++i) {
        cin >> L[i] >> R[i];
        t[i] = -1;
    }
    vector<triple> zap(q);
    int kol1 = 0;
    bool was = false;
    int pred = 0;
    for (int i = 0; i < q; ++i) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r, x;
            cin >> l >> r >> x;
            zap[i] = {l, r, x};
            kol1++;
        } else {
            int x;
            cin >> x;
            zap[i] = {0, 0, x};
        }
        if (pred == 2 && type == 1) {
            was = true;
        }
        pred = type;
    }
    if ((n <= 5000 && q <= 5000) || kol1 <= 10) {
        dfs(1);
        for (int i = 0; i < q; ++i) {
            int type;
            if (zap[i].l == 0) {
                type = 2;
            } else {
                type = 1;
            }
            if (type == 1) {
                auto [l, r, x] = zap[i];
                for (int j = l; j <= r; ++j) {
                    t[j] = x;
                }
                sum = 1;
                dfs(1);
            } else {
                int x = zap[i].x;
                cout << otv[x] << "\n";
            }
        }
    } else if (!was) {
        int tek = q;
        build3(1, 1, n);
        for (int i = 0; i < q; ++i) {
            if (zap[i].l == 0) {
                tek = i;
                break;
            }
            auto [l, r, zn] = zap[i];
            update3(1, 1, n, l, r, zn);
        }
        find3(1, 1, n);
        dfs(1);
        for (int i = tek; i < q; ++i) {
            cout << otv[zap[i].x] << "\n";
        }
    }
    return 0;
}
